/* slurp-manager-job.h
 *
 * Copyright © 2018 Julian Richen <julian@richen.io>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "slurp-resource.h"

#include <glib-object.h>
#include <glib.h>

G_BEGIN_DECLS

#define SLURP_TYPE_MANAGER_JOB (slurp_manager_job_get_type())

typedef struct _SlurpManagerJob SlurpManagerJob;

struct _SlurpManagerJob
{
    guint ref_count;

    SlurpResource *resource;
    GCancellable *cancellable;
};

SlurpManagerJob *
slurp_manager_job_new (void);

SlurpManagerJob *
slurp_manager_job_copy (SlurpManagerJob *self);

SlurpManagerJob *
slurp_manager_job_ref (SlurpManagerJob *self);

void
slurp_manager_job_unref (SlurpManagerJob *self);

G_DEFINE_AUTOPTR_CLEANUP_FUNC (SlurpManagerJob, slurp_manager_job_unref)

G_END_DECLS
